<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Error Handling</TITLE>
<link href="suif1_107.html" rel=Next>
<link href="suif1_105.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_105.html">previous</A>, <A HREF="suif1_107.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC106" HREF="suif1_toc.html#TOC106">Error Handling</A></H2>
<P>
<A NAME="IDX748"></A>
<A NAME="IDX749"></A>
<A NAME="IDX750"></A>

</P>
<P>
The SUIF library includes a number of functions for error handling.
These functions handle three kinds of problems: errors, warnings, and
assertions.  Assertions are tests for things that should never occur in
a correct program.  Any problem that could potentially occur in a
correct program due to bad input or other external conditions should be
treated as an error rather than an assertion failure.  Warnings are used
to report potentially troublesome conditions that are not serious enough
to cause a fatal error.

</P>
<P>
<A NAME="IDX751"></A>
<A NAME="IDX752"></A>
Two macros are available to implement assertions.  The <CODE>assert</CODE>
macro takes a single expression as an argument.  If the expression
evaluates to zero, a message is printed showing the current line number,
file name, and the expression that failed, and then the <CODE>abort</CODE>
function is called to terminate the program.  The <CODE>assert_msg</CODE>
macro is similar except that it also prints a user-defined message if
the assertion fails.  Besides the expression to be tested,
<CODE>assert_msg</CODE> takes an argument that contains the message to
be printed.  This second argument must hold the <CODE>printf</CODE> format
string and the arguments for the call to <CODE>printf</CODE>, separated by
commas.  To keep the commas from splitting up the second argument, it
must be surrounded by parentheses.  For example:

</P>

<PRE>
assert_msg(sym-&#62;parent(), ("no parent for %s", sym-&#62;name()));
</PRE>

<P>
<A NAME="IDX753"></A>
<A NAME="IDX754"></A>
Errors may be reported using the <CODE>error_line</CODE> function.  The
<CODE>return_code</CODE> parameter specifies the method of terminating the
program.  If the return code is negative, the <CODE>abort</CODE> function is
called.  If it is greater than zero, the <CODE>exit</CODE> function is called
with the specified return code.  If the return code is zero, the error
message will be printed but the program will not terminate.  The
<CODE>the_node</CODE> parameter is optional and may be set to <CODE>NULL</CODE>.  If
used, it points to the AST node closest to the point where the error was
detected, and the library tries to use it to find and print the
corresponding source line number.  Finally, the <CODE>fmt</CODE> parameter
specifies the <CODE>printf</CODE> format string used to print the error
message and any additional parameters are passed on to <CODE>printf</CODE>.
The <CODE>verror_line</CODE> function is identical to <CODE>error_line</CODE> except
that it passes the variable arguments for <CODE>printf</CODE> using a
<CODE>varargs</CODE>-style list.  This is just like the standard
<CODE>vprintf</CODE> function.

</P>
<P>
<A NAME="IDX755"></A>
<A NAME="IDX756"></A>
The <CODE>warning_line</CODE> and <CODE>vwarning_line</CODE> functions are just like
the corresponding error functions, except that they print warning
messages and do not terminate the program.  Consequently, they do not
have <CODE>return_code</CODE> parameters.

</P>
<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_105.html">previous</A>, <A HREF="suif1_107.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
